<script lang="ts">
  import { numberWithCommas } from "src/functions/comma-number";

  import { Page } from "src/page";
  import { pageSelectedStore, cartOrdersStore } from "src/store";
  import { fade } from "svelte/transition";

  let showMenu = false;
  let timeOutSubscribe: any = null;

  let itemInStock = Array(10);

  function onMouseOut() {
    timeOutSubscribe = setTimeout(function () {
      showMenu = false;
    }, 2000);
  }

  function onMouseOver() {
    showMenu = true;
    clearTimeout(timeOutSubscribe);
  }

  $: prodCountInCart =
    $cartOrdersStore && $cartOrdersStore.length > 0
      ? $cartOrdersStore.filter((cos) => Object.values(cos).length)
      : [];
</script>

<div class="flex items-center">
  <div class="flex justify-end items-center text-gray-800 mx-2">
    <div
      on:click={() => {
        ($pageSelectedStore = Page.CART), (showMenu = false);
      }}
      on:mouseenter={() => (showMenu = true)}
      on:mouseleave={onMouseOut}
      class="relative text-gray-800"
    >
      <div role="button" aria-describedby="stardust-popover2" class="">
        <div class="flex items-center py-2 px-0 h-full">
          <div
            class="flex items-center m-0 text-indigo-700 no-underline bg-transparent cursor-pointer"
            id="options-menu"
            aria-expanded="true"
            aria-haspopup="true"
          >
            <svg
              viewBox="0 0 26.6 25.6"
              class="inline-block relative mr-2 w-6 h-6 text-base leading-5 text-white"
              style="fill: currentcolor; stroke: rgb(255, 255, 255);"
            >
              <polyline
                fill="none"
                points="2 1.7 5.5 1.7 9.6 18.3 21.2 18.3 24.6 6.1 7 6.1"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-miterlimit="10"
                stroke-width="2.5"
                class=""
              />
              <circle cx="10.7" cy="23" r="2.2" stroke="none" class="" />
              <circle cx="19.7" cy="23" r="2.2" stroke="none" class="" />
            </svg>

            {#if prodCountInCart.length}
              <div
                class="relative py-0 px-2 -mr-5 h-5 leading-5 text-center bg-red-500 text-white border-solid rounded-full"
                style="border-radius: 44px; min-width: 0.6875rem; left: -1.25rem; top: -0.6875rem;"
              >
                {prodCountInCart.length}
              </div>
            {/if}
          </div>
        </div>
      </div>
    </div>
  </div>

  {#if showMenu && $cartOrdersStore && $cartOrdersStore.length}
    <div
      transition:fade
      on:mouseenter={onMouseOver}
      on:mouseleave={() => (showMenu = false)}
      class="rounded"
    >
      <div
        class="origin-top-right absolute right-0 mt-5 mr-4 w-80 rounded shadow-lg bg-white ring-1 ring-black ring-opacity-5 focus:outline-none"
        role="menu"
        aria-orientation="vertical"
        aria-labelledby="options-menu"
      >
        <div
          class="relative w-0 h-0 leading-4 text-gray-800 border-transparent border-solid"
          style="border-bottom: 10px solid rgb(255, 255, 255); border-left: 14px solid transparent; border-right: 14px solid transparent; bottom: 10px; left: 275px;"
        />

        <div
          class="flex items-center pl-2 h-10 leading-4 text-gray-500 capitalize"
        >
          สินค้าที่เพิ่งเพิ่มเข้าไป
        </div>
        {#each $cartOrdersStore as cartOrder}
          <div
            class="flex relative p-2 w-full leading-4 text-gray-800 box-border hover:bg-gray-100 cursor-pointer"
          >
            <img
              alt="productImg"
              class="flex-shrink-0 w-10 h-10 text-gray-800 bg-no-repeat bg-cover border border-gray-300 border-solid"
              src={cartOrder.image}
            />
            <div class="overflow-hidden flex-1 ml-2 text-gray-800">
              <div class="flex items-center">
                <div class="font-medium truncate">
                  {cartOrder.productName || "-"}
                </div>
                <div class="flex-1" />
                <div class="flex flex-shrink-0 items-baseline ml-10">
                  <div class="text-red-600">
                    ฿{numberWithCommas(cartOrder.sumPrice)}
                  </div>
                </div>
              </div>
            </div>
          </div>
        {/each}
        <div
          class="flex items-center p-2 h-10 text-xs leading-10 text-center text-gray-800 capitalize bg-white"
        >
          <div class="flex-1 leading-10 text-gray-800 capitalize" />
          <div
            on:click={() => ($pageSelectedStore = Page.CART)}
            class="inline-flex overflow-hidden flex-col flex-shrink-0 justify-center items-center py-0 px-4 h-8 text-sm text-center text-white no-underline capitalize bg-red-700 rounded-sm border-0 cursor-pointer box-border shadow-xs hover:bg-red-700 focus:bg-red-700 focus:shadow-xs"
            href="/cart"
            style="text-overflow: ellipsis; outline: 0px; min-width: 60px; max-width: unset;"
          >
            ดูรถเข็นของคุณ
          </div>
        </div>
      </div>
    </div>
  {/if}
</div>
